"""
    HCL AppScan on Cloud (v2)

    This API allows you to interact with the service. The API allows you to perform many of the operations available in the UI and more.</br>For authentication, use the relevant APIs in the Account section. A successful authentication response includes a bearer token for use in subsequent API calls. Pasting this token in the 'Access token' field above will automatically add the authorization header to any API call that requires a valid session.

    OpenAPI spec version: v2

    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

from pyasoc.configuration import Configuration


class AppScanSaaSModelsV2BusinessUnitModel:
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {"id": "str", "name": "str", "num_applications": "int"}

    attribute_map = {"id": "Id", "name": "Name", "num_applications": "NumApplications"}

    def __init__(self, id=None, name=None, num_applications=None, _configuration=None):
        """AppScanSaaSModelsV2BusinessUnitModel - a model defined in Swagger"""
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._id = None
        self._name = None
        self._num_applications = None
        self.discriminator = None

        if id is not None:
            self.id = id
        if name is not None:
            self.name = name
        if num_applications is not None:
            self.num_applications = num_applications

    @property
    def id(self):
        # type: () -> str
        """Gets the id of this AppScanSaaSModelsV2BusinessUnitModel.


        :return: The id of this AppScanSaaSModelsV2BusinessUnitModel.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this AppScanSaaSModelsV2BusinessUnitModel.


        :param id: The id of this AppScanSaaSModelsV2BusinessUnitModel.
        :type: str
        """

        self._id = id

    @property
    def name(self):
        # type: () -> str
        """Gets the name of this AppScanSaaSModelsV2BusinessUnitModel.


        :return: The name of this AppScanSaaSModelsV2BusinessUnitModel.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this AppScanSaaSModelsV2BusinessUnitModel.


        :param name: The name of this AppScanSaaSModelsV2BusinessUnitModel.
        :type: str
        """
        if self._configuration.client_side_validation and name is not None and len(name) > 256:
            raise ValueError("Invalid value for `name`, length must be less than or equal to `256`")
        if self._configuration.client_side_validation and name is not None and len(name) < 0:
            raise ValueError(
                "Invalid value for `name`, length must be greater than or equal to `0`"
            )

        self._name = name

    @property
    def num_applications(self):
        # type: () -> int
        """Gets the num_applications of this AppScanSaaSModelsV2BusinessUnitModel.


        :return: The num_applications of this AppScanSaaSModelsV2BusinessUnitModel.
        :rtype: int
        """
        return self._num_applications

    @num_applications.setter
    def num_applications(self, num_applications):
        """Sets the num_applications of this AppScanSaaSModelsV2BusinessUnitModel.


        :param num_applications: The num_applications of this AppScanSaaSModelsV2BusinessUnitModel.
        :type: int
        """

        self._num_applications = num_applications

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in self.swagger_types.items():
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(
                    map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value)
                )
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict())
                        if hasattr(item[1], "to_dict")
                        else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value
        if issubclass(AppScanSaaSModelsV2BusinessUnitModel, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AppScanSaaSModelsV2BusinessUnitModel):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AppScanSaaSModelsV2BusinessUnitModel):
            return True

        return self.to_dict() != other.to_dict()
