"""
    HCL AppScan on Cloud (v2)

    This API allows you to interact with the service. The API allows you to perform many of the operations available in the UI and more.</br>For authentication, use the relevant APIs in the Account section. A successful authentication response includes a bearer token for use in subsequent API calls. Pasting this token in the 'Access token' field above will automatically add the authorization header to any API call that requires a valid session.

    OpenAPI spec version: v2

    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

from pyasoc.configuration import Configuration


class AppScanSaaSModelsV2MinPresenceData:
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {"presence_name": "str", "status": "str"}

    attribute_map = {"presence_name": "PresenceName", "status": "Status"}

    def __init__(self, presence_name=None, status=None, _configuration=None):
        """AppScanSaaSModelsV2MinPresenceData - a model defined in Swagger"""
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._presence_name = None
        self._status = None
        self.discriminator = None

        if presence_name is not None:
            self.presence_name = presence_name
        if status is not None:
            self.status = status

    @property
    def presence_name(self):
        # type: () -> str
        """Gets the presence_name of this AppScanSaaSModelsV2MinPresenceData.


        :return: The presence_name of this AppScanSaaSModelsV2MinPresenceData.
        :rtype: str
        """
        return self._presence_name

    @presence_name.setter
    def presence_name(self, presence_name):
        """Sets the presence_name of this AppScanSaaSModelsV2MinPresenceData.


        :param presence_name: The presence_name of this AppScanSaaSModelsV2MinPresenceData.
        :type: str
        """

        self._presence_name = presence_name

    @property
    def status(self):
        # type: () -> str
        """Gets the status of this AppScanSaaSModelsV2MinPresenceData.


        :return: The status of this AppScanSaaSModelsV2MinPresenceData.
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this AppScanSaaSModelsV2MinPresenceData.


        :param status: The status of this AppScanSaaSModelsV2MinPresenceData.
        :type: str
        """
        allowed_values = [
            "Active",
            "NeverUsed",
            "KeyExpired",
            "KeyNeverUsed",
            "Inactive",
            "Disable",
        ]
        if self._configuration.client_side_validation and status not in allowed_values:
            raise ValueError(
                f"Invalid value for `status` ({status}), must be one of {allowed_values}"
            )

        self._status = status

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in self.swagger_types.items():
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(
                    map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value)
                )
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict())
                        if hasattr(item[1], "to_dict")
                        else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value
        if issubclass(AppScanSaaSModelsV2MinPresenceData, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AppScanSaaSModelsV2MinPresenceData):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AppScanSaaSModelsV2MinPresenceData):
            return True

        return self.to_dict() != other.to_dict()
