"""
    HCL AppScan on Cloud (v2)

    This API allows you to interact with the service. The API allows you to perform many of the operations available in the UI and more.</br>For authentication, use the relevant APIs in the Account section. A successful authentication response includes a bearer token for use in subsequent API calls. Pasting this token in the 'Access token' field above will automatically add the authorization header to any API call that requires a valid session.

    OpenAPI spec version: v2

    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
from typing import TYPE_CHECKING

from pyasoc.configuration import Configuration

if TYPE_CHECKING:
    from pyasoc.models import AppScanSaaSModelsV2MinScanExecution


class AppScanSaaSModelsV2MinScanData:
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        "app_id": "str",
        "id": "str",
        "name": "str",
        "technology": "str",
        "iast_agent_type": "str",
        "iast_agent_status": "str",
        "url": "str",
        "app_name": "str",
        "test_optimization_level": "str",
        "number_of_executions": "int",
        "created_by": "UserSiteCommonModelsBasicUserInfo",
        "created_at": "datetime",
        "last_modified": "datetime",
        "next_scheduled_run": "datetime",
        "latest_execution": "AppScanSaaSModelsV2MinScanExecution",
        "presence": "AppScanSaaSModelsV2MinPresenceData",
        "recurrence_rule": "str",
        "is_personal": "bool",
        "rescan_allowed": "bool",
        "parsed_from_uploaded_file": "bool",
        "deleted_allowed": "bool",
        "recurrence_end_date": "datetime",
        "fully_automatic": "bool",
        "enable_mail_notifications": "bool",
    }

    attribute_map = {
        "app_id": "AppId",
        "id": "Id",
        "name": "Name",
        "technology": "Technology",
        "iast_agent_type": "IastAgentType",
        "iast_agent_status": "IastAgentStatus",
        "url": "Url",
        "app_name": "AppName",
        "test_optimization_level": "TestOptimizationLevel",
        "number_of_executions": "NumberOfExecutions",
        "created_by": "CreatedBy",
        "created_at": "CreatedAt",
        "last_modified": "LastModified",
        "next_scheduled_run": "NextScheduledRun",
        "latest_execution": "LatestExecution",
        "presence": "Presence",
        "recurrence_rule": "RecurrenceRule",
        "is_personal": "IsPersonal",
        "rescan_allowed": "RescanAllowed",
        "parsed_from_uploaded_file": "ParsedFromUploadedFile",
        "deleted_allowed": "DeletedAllowed",
        "recurrence_end_date": "RecurrenceEndDate",
        "fully_automatic": "FullyAutomatic",
        "enable_mail_notifications": "EnableMailNotifications",
    }

    def __init__(
        self,
        app_id=None,
        id=None,
        name=None,
        technology=None,
        iast_agent_type=None,
        iast_agent_status=None,
        url=None,
        app_name=None,
        test_optimization_level=None,
        number_of_executions=None,
        created_by=None,
        created_at=None,
        last_modified=None,
        next_scheduled_run=None,
        latest_execution=None,
        presence=None,
        recurrence_rule=None,
        is_personal=None,
        rescan_allowed=None,
        parsed_from_uploaded_file=None,
        deleted_allowed=None,
        recurrence_end_date=None,
        fully_automatic=None,
        enable_mail_notifications=None,
        _configuration=None,
    ):
        """AppScanSaaSModelsV2MinScanData - a model defined in Swagger"""
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._app_id = None
        self._id = None
        self._name = None
        self._technology = None
        self._iast_agent_type = None
        self._iast_agent_status = None
        self._url = None
        self._app_name = None
        self._test_optimization_level = None
        self._number_of_executions = None
        self._created_by = None
        self._created_at = None
        self._last_modified = None
        self._next_scheduled_run = None
        self._latest_execution = None
        self._presence = None
        self._recurrence_rule = None
        self._is_personal = None
        self._rescan_allowed = None
        self._parsed_from_uploaded_file = None
        self._deleted_allowed = None
        self._recurrence_end_date = None
        self._fully_automatic = None
        self._enable_mail_notifications = None
        self.discriminator = None

        if app_id is not None:
            self.app_id = app_id
        if id is not None:
            self.id = id
        if name is not None:
            self.name = name
        if technology is not None:
            self.technology = technology
        if iast_agent_type is not None:
            self.iast_agent_type = iast_agent_type
        if iast_agent_status is not None:
            self.iast_agent_status = iast_agent_status
        if url is not None:
            self.url = url
        if app_name is not None:
            self.app_name = app_name
        if test_optimization_level is not None:
            self.test_optimization_level = test_optimization_level
        if number_of_executions is not None:
            self.number_of_executions = number_of_executions
        if created_by is not None:
            self.created_by = created_by
        if created_at is not None:
            self.created_at = created_at
        if last_modified is not None:
            self.last_modified = last_modified
        if next_scheduled_run is not None:
            self.next_scheduled_run = next_scheduled_run
        if latest_execution is not None:
            self.latest_execution = latest_execution
        if presence is not None:
            self.presence = presence
        if recurrence_rule is not None:
            self.recurrence_rule = recurrence_rule
        if is_personal is not None:
            self.is_personal = is_personal
        if rescan_allowed is not None:
            self.rescan_allowed = rescan_allowed
        if parsed_from_uploaded_file is not None:
            self.parsed_from_uploaded_file = parsed_from_uploaded_file
        if deleted_allowed is not None:
            self.deleted_allowed = deleted_allowed
        if recurrence_end_date is not None:
            self.recurrence_end_date = recurrence_end_date
        if fully_automatic is not None:
            self.fully_automatic = fully_automatic
        if enable_mail_notifications is not None:
            self.enable_mail_notifications = enable_mail_notifications

    @property
    def app_id(self):
        # type: () -> str
        """Gets the app_id of this AppScanSaaSModelsV2MinScanData.


        :return: The app_id of this AppScanSaaSModelsV2MinScanData.
        :rtype: str
        """
        return self._app_id

    @app_id.setter
    def app_id(self, app_id):
        """Sets the app_id of this AppScanSaaSModelsV2MinScanData.


        :param app_id: The app_id of this AppScanSaaSModelsV2MinScanData.
        :type: str
        """

        self._app_id = app_id

    @property
    def id(self):
        # type: () -> str
        """Gets the id of this AppScanSaaSModelsV2MinScanData.


        :return: The id of this AppScanSaaSModelsV2MinScanData.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this AppScanSaaSModelsV2MinScanData.


        :param id: The id of this AppScanSaaSModelsV2MinScanData.
        :type: str
        """

        self._id = id

    @property
    def name(self):
        # type: () -> str
        """Gets the name of this AppScanSaaSModelsV2MinScanData.


        :return: The name of this AppScanSaaSModelsV2MinScanData.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this AppScanSaaSModelsV2MinScanData.


        :param name: The name of this AppScanSaaSModelsV2MinScanData.
        :type: str
        """

        self._name = name

    @property
    def technology(self):
        # type: () -> str
        """Gets the technology of this AppScanSaaSModelsV2MinScanData.


        :return: The technology of this AppScanSaaSModelsV2MinScanData.
        :rtype: str
        """
        return self._technology

    @technology.setter
    def technology(self, technology):
        """Sets the technology of this AppScanSaaSModelsV2MinScanData.


        :param technology: The technology of this AppScanSaaSModelsV2MinScanData.
        :type: str
        """
        allowed_values = [
            "DynamicAnalyzer",
            "StaticAnalyzer",
            "MobileAnalyzerAndroid",
            "MobileAnalyzerIos",
            "IFA",
            "DastAutomation",
            "IASTAnalyzer",
            "ScaAnalyzer",
        ]
        if self._configuration.client_side_validation and technology not in allowed_values:
            raise ValueError(
                "Invalid value for `technology` ({}), must be one of {}".format(
                    technology, allowed_values
                )
            )

        self._technology = technology

    @property
    def iast_agent_type(self):
        # type: () -> str
        """Gets the iast_agent_type of this AppScanSaaSModelsV2MinScanData.


        :return: The iast_agent_type of this AppScanSaaSModelsV2MinScanData.
        :rtype: str
        """
        return self._iast_agent_type

    @iast_agent_type.setter
    def iast_agent_type(self, iast_agent_type):
        """Sets the iast_agent_type of this AppScanSaaSModelsV2MinScanData.


        :param iast_agent_type: The iast_agent_type of this AppScanSaaSModelsV2MinScanData.
        :type: str
        """
        allowed_values = ["Java", "DotNet", "NodeJS"]
        if self._configuration.client_side_validation and iast_agent_type not in allowed_values:
            raise ValueError(
                "Invalid value for `iast_agent_type` ({}), must be one of {}".format(
                    iast_agent_type, allowed_values
                )
            )

        self._iast_agent_type = iast_agent_type

    @property
    def iast_agent_status(self):
        # type: () -> str
        """Gets the iast_agent_status of this AppScanSaaSModelsV2MinScanData.


        :return: The iast_agent_status of this AppScanSaaSModelsV2MinScanData.
        :rtype: str
        """
        return self._iast_agent_status

    @iast_agent_status.setter
    def iast_agent_status(self, iast_agent_status):
        """Sets the iast_agent_status of this AppScanSaaSModelsV2MinScanData.


        :param iast_agent_status: The iast_agent_status of this AppScanSaaSModelsV2MinScanData.
        :type: str
        """
        allowed_values = ["None", "Active", "KeyNeverUsed", "Inactive"]
        if self._configuration.client_side_validation and iast_agent_status not in allowed_values:
            raise ValueError(
                "Invalid value for `iast_agent_status` ({}), must be one of {}".format(
                    iast_agent_status, allowed_values
                )
            )

        self._iast_agent_status = iast_agent_status

    @property
    def url(self):
        # type: () -> str
        """Gets the url of this AppScanSaaSModelsV2MinScanData.


        :return: The url of this AppScanSaaSModelsV2MinScanData.
        :rtype: str
        """
        return self._url

    @url.setter
    def url(self, url):
        """Sets the url of this AppScanSaaSModelsV2MinScanData.


        :param url: The url of this AppScanSaaSModelsV2MinScanData.
        :type: str
        """

        self._url = url

    @property
    def app_name(self):
        # type: () -> str
        """Gets the app_name of this AppScanSaaSModelsV2MinScanData.


        :return: The app_name of this AppScanSaaSModelsV2MinScanData.
        :rtype: str
        """
        return self._app_name

    @app_name.setter
    def app_name(self, app_name):
        """Sets the app_name of this AppScanSaaSModelsV2MinScanData.


        :param app_name: The app_name of this AppScanSaaSModelsV2MinScanData.
        :type: str
        """

        self._app_name = app_name

    @property
    def test_optimization_level(self):
        # type: () -> str
        """Gets the test_optimization_level of this AppScanSaaSModelsV2MinScanData.


        :return: The test_optimization_level of this AppScanSaaSModelsV2MinScanData.
        :rtype: str
        """
        return self._test_optimization_level

    @test_optimization_level.setter
    def test_optimization_level(self, test_optimization_level):
        """Sets the test_optimization_level of this AppScanSaaSModelsV2MinScanData.


        :param test_optimization_level: The test_optimization_level of this AppScanSaaSModelsV2MinScanData.
        :type: str
        """
        allowed_values = ["NoOptimization", "Fast", "Faster", "Fastest"]
        if (
            self._configuration.client_side_validation
            and test_optimization_level not in allowed_values
        ):
            raise ValueError(
                "Invalid value for `test_optimization_level` ({}), must be one of {}".format(
                    test_optimization_level, allowed_values
                )
            )

        self._test_optimization_level = test_optimization_level

    @property
    def number_of_executions(self):
        # type: () -> int
        """Gets the number_of_executions of this AppScanSaaSModelsV2MinScanData.


        :return: The number_of_executions of this AppScanSaaSModelsV2MinScanData.
        :rtype: int
        """
        return self._number_of_executions

    @number_of_executions.setter
    def number_of_executions(self, number_of_executions):
        """Sets the number_of_executions of this AppScanSaaSModelsV2MinScanData.


        :param number_of_executions: The number_of_executions of this AppScanSaaSModelsV2MinScanData.
        :type: int
        """

        self._number_of_executions = number_of_executions

    @property
    def created_by(self):
        # type: () -> UserSiteCommonModelsBasicUserInfo
        """Gets the created_by of this AppScanSaaSModelsV2MinScanData.


        :return: The created_by of this AppScanSaaSModelsV2MinScanData.
        :rtype: UserSiteCommonModelsBasicUserInfo
        """
        return self._created_by

    @created_by.setter
    def created_by(self, created_by):
        """Sets the created_by of this AppScanSaaSModelsV2MinScanData.


        :param created_by: The created_by of this AppScanSaaSModelsV2MinScanData.
        :type: UserSiteCommonModelsBasicUserInfo
        """

        self._created_by = created_by

    @property
    def created_at(self):
        # type: () -> datetime
        """Gets the created_at of this AppScanSaaSModelsV2MinScanData.


        :return: The created_at of this AppScanSaaSModelsV2MinScanData.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this AppScanSaaSModelsV2MinScanData.


        :param created_at: The created_at of this AppScanSaaSModelsV2MinScanData.
        :type: datetime
        """

        self._created_at = created_at

    @property
    def last_modified(self):
        # type: () -> datetime
        """Gets the last_modified of this AppScanSaaSModelsV2MinScanData.


        :return: The last_modified of this AppScanSaaSModelsV2MinScanData.
        :rtype: datetime
        """
        return self._last_modified

    @last_modified.setter
    def last_modified(self, last_modified):
        """Sets the last_modified of this AppScanSaaSModelsV2MinScanData.


        :param last_modified: The last_modified of this AppScanSaaSModelsV2MinScanData.
        :type: datetime
        """

        self._last_modified = last_modified

    @property
    def next_scheduled_run(self):
        # type: () -> datetime
        """Gets the next_scheduled_run of this AppScanSaaSModelsV2MinScanData.


        :return: The next_scheduled_run of this AppScanSaaSModelsV2MinScanData.
        :rtype: datetime
        """
        return self._next_scheduled_run

    @next_scheduled_run.setter
    def next_scheduled_run(self, next_scheduled_run):
        """Sets the next_scheduled_run of this AppScanSaaSModelsV2MinScanData.


        :param next_scheduled_run: The next_scheduled_run of this AppScanSaaSModelsV2MinScanData.
        :type: datetime
        """

        self._next_scheduled_run = next_scheduled_run

    @property
    def latest_execution(self):
        # type: () -> AppScanSaaSModelsV2MinScanExecution
        """Gets the latest_execution of this AppScanSaaSModelsV2MinScanData.


        :return: The latest_execution of this AppScanSaaSModelsV2MinScanData.
        :rtype: AppScanSaaSModelsV2MinScanExecution
        """
        return self._latest_execution

    @latest_execution.setter
    def latest_execution(self, latest_execution):
        """Sets the latest_execution of this AppScanSaaSModelsV2MinScanData.


        :param latest_execution: The latest_execution of this AppScanSaaSModelsV2MinScanData.
        :type: AppScanSaaSModelsV2MinScanExecution
        """

        self._latest_execution = latest_execution

    @property
    def presence(self):
        # type: () -> AppScanSaaSModelsV2MinPresenceData
        """Gets the presence of this AppScanSaaSModelsV2MinScanData.


        :return: The presence of this AppScanSaaSModelsV2MinScanData.
        :rtype: AppScanSaaSModelsV2MinPresenceData
        """
        return self._presence

    @presence.setter
    def presence(self, presence):
        """Sets the presence of this AppScanSaaSModelsV2MinScanData.


        :param presence: The presence of this AppScanSaaSModelsV2MinScanData.
        :type: AppScanSaaSModelsV2MinPresenceData
        """

        self._presence = presence

    @property
    def recurrence_rule(self):
        # type: () -> str
        """Gets the recurrence_rule of this AppScanSaaSModelsV2MinScanData.


        :return: The recurrence_rule of this AppScanSaaSModelsV2MinScanData.
        :rtype: str
        """
        return self._recurrence_rule

    @recurrence_rule.setter
    def recurrence_rule(self, recurrence_rule):
        """Sets the recurrence_rule of this AppScanSaaSModelsV2MinScanData.


        :param recurrence_rule: The recurrence_rule of this AppScanSaaSModelsV2MinScanData.
        :type: str
        """

        self._recurrence_rule = recurrence_rule

    @property
    def is_personal(self):
        # type: () -> bool
        """Gets the is_personal of this AppScanSaaSModelsV2MinScanData.


        :return: The is_personal of this AppScanSaaSModelsV2MinScanData.
        :rtype: bool
        """
        return self._is_personal

    @is_personal.setter
    def is_personal(self, is_personal):
        """Sets the is_personal of this AppScanSaaSModelsV2MinScanData.


        :param is_personal: The is_personal of this AppScanSaaSModelsV2MinScanData.
        :type: bool
        """

        self._is_personal = is_personal

    @property
    def rescan_allowed(self):
        # type: () -> bool
        """Gets the rescan_allowed of this AppScanSaaSModelsV2MinScanData.


        :return: The rescan_allowed of this AppScanSaaSModelsV2MinScanData.
        :rtype: bool
        """
        return self._rescan_allowed

    @rescan_allowed.setter
    def rescan_allowed(self, rescan_allowed):
        """Sets the rescan_allowed of this AppScanSaaSModelsV2MinScanData.


        :param rescan_allowed: The rescan_allowed of this AppScanSaaSModelsV2MinScanData.
        :type: bool
        """

        self._rescan_allowed = rescan_allowed

    @property
    def parsed_from_uploaded_file(self):
        # type: () -> bool
        """Gets the parsed_from_uploaded_file of this AppScanSaaSModelsV2MinScanData.


        :return: The parsed_from_uploaded_file of this AppScanSaaSModelsV2MinScanData.
        :rtype: bool
        """
        return self._parsed_from_uploaded_file

    @parsed_from_uploaded_file.setter
    def parsed_from_uploaded_file(self, parsed_from_uploaded_file):
        """Sets the parsed_from_uploaded_file of this AppScanSaaSModelsV2MinScanData.


        :param parsed_from_uploaded_file: The parsed_from_uploaded_file of this AppScanSaaSModelsV2MinScanData.
        :type: bool
        """

        self._parsed_from_uploaded_file = parsed_from_uploaded_file

    @property
    def deleted_allowed(self):
        # type: () -> bool
        """Gets the deleted_allowed of this AppScanSaaSModelsV2MinScanData.


        :return: The deleted_allowed of this AppScanSaaSModelsV2MinScanData.
        :rtype: bool
        """
        return self._deleted_allowed

    @deleted_allowed.setter
    def deleted_allowed(self, deleted_allowed):
        """Sets the deleted_allowed of this AppScanSaaSModelsV2MinScanData.


        :param deleted_allowed: The deleted_allowed of this AppScanSaaSModelsV2MinScanData.
        :type: bool
        """

        self._deleted_allowed = deleted_allowed

    @property
    def recurrence_end_date(self):
        # type: () -> datetime
        """Gets the recurrence_end_date of this AppScanSaaSModelsV2MinScanData.


        :return: The recurrence_end_date of this AppScanSaaSModelsV2MinScanData.
        :rtype: datetime
        """
        return self._recurrence_end_date

    @recurrence_end_date.setter
    def recurrence_end_date(self, recurrence_end_date):
        """Sets the recurrence_end_date of this AppScanSaaSModelsV2MinScanData.


        :param recurrence_end_date: The recurrence_end_date of this AppScanSaaSModelsV2MinScanData.
        :type: datetime
        """

        self._recurrence_end_date = recurrence_end_date

    @property
    def fully_automatic(self):
        # type: () -> bool
        """Gets the fully_automatic of this AppScanSaaSModelsV2MinScanData.


        :return: The fully_automatic of this AppScanSaaSModelsV2MinScanData.
        :rtype: bool
        """
        return self._fully_automatic

    @fully_automatic.setter
    def fully_automatic(self, fully_automatic):
        """Sets the fully_automatic of this AppScanSaaSModelsV2MinScanData.


        :param fully_automatic: The fully_automatic of this AppScanSaaSModelsV2MinScanData.
        :type: bool
        """

        self._fully_automatic = fully_automatic

    @property
    def enable_mail_notifications(self):
        # type: () -> bool
        """Gets the enable_mail_notifications of this AppScanSaaSModelsV2MinScanData.


        :return: The enable_mail_notifications of this AppScanSaaSModelsV2MinScanData.
        :rtype: bool
        """
        return self._enable_mail_notifications

    @enable_mail_notifications.setter
    def enable_mail_notifications(self, enable_mail_notifications):
        """Sets the enable_mail_notifications of this AppScanSaaSModelsV2MinScanData.


        :param enable_mail_notifications: The enable_mail_notifications of this AppScanSaaSModelsV2MinScanData.
        :type: bool
        """

        self._enable_mail_notifications = enable_mail_notifications

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in self.swagger_types.items():
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(
                    map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value)
                )
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict())
                        if hasattr(item[1], "to_dict")
                        else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value
        if issubclass(AppScanSaaSModelsV2MinScanData, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AppScanSaaSModelsV2MinScanData):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AppScanSaaSModelsV2MinScanData):
            return True

        return self.to_dict() != other.to_dict()
