"""
    HCL AppScan on Cloud (v2)

    This API allows you to interact with the service. The API allows you to perform many of the operations available in the UI and more.</br>For authentication, use the relevant APIs in the Account section. A successful authentication response includes a bearer token for use in subsequent API calls. Pasting this token in the 'Access token' field above will automatically add the authorization header to any API call that requires a valid session.

    OpenAPI spec version: v2

    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

from pyasoc.configuration import Configuration


class AppScanSaaSModelsV2UpdateBusinessUnitModel:
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        "app_ids_to_remove": "list[str]",
        "name": "str",
        "app_ids_to_add": "list[str]",
    }

    attribute_map = {
        "app_ids_to_remove": "AppIdsToRemove",
        "name": "Name",
        "app_ids_to_add": "AppIdsToAdd",
    }

    def __init__(
        self,
        app_ids_to_remove=None,
        name=None,
        app_ids_to_add=None,
        _configuration=None,
    ):
        """AppScanSaaSModelsV2UpdateBusinessUnitModel - a model defined in Swagger"""
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._app_ids_to_remove = None
        self._name = None
        self._app_ids_to_add = None
        self.discriminator = None

        if app_ids_to_remove is not None:
            self.app_ids_to_remove = app_ids_to_remove
        if name is not None:
            self.name = name
        if app_ids_to_add is not None:
            self.app_ids_to_add = app_ids_to_add

    @property
    def app_ids_to_remove(self):
        # type: () -> list[str]
        """Gets the app_ids_to_remove of this AppScanSaaSModelsV2UpdateBusinessUnitModel.


        :return: The app_ids_to_remove of this AppScanSaaSModelsV2UpdateBusinessUnitModel.
        :rtype: list[str]
        """
        return self._app_ids_to_remove

    @app_ids_to_remove.setter
    def app_ids_to_remove(self, app_ids_to_remove):
        """Sets the app_ids_to_remove of this AppScanSaaSModelsV2UpdateBusinessUnitModel.


        :param app_ids_to_remove: The app_ids_to_remove of this AppScanSaaSModelsV2UpdateBusinessUnitModel.
        :type: list[str]
        """

        self._app_ids_to_remove = app_ids_to_remove

    @property
    def name(self):
        # type: () -> str
        """Gets the name of this AppScanSaaSModelsV2UpdateBusinessUnitModel.


        :return: The name of this AppScanSaaSModelsV2UpdateBusinessUnitModel.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this AppScanSaaSModelsV2UpdateBusinessUnitModel.


        :param name: The name of this AppScanSaaSModelsV2UpdateBusinessUnitModel.
        :type: str
        """
        if self._configuration.client_side_validation and name is not None and len(name) > 256:
            raise ValueError("Invalid value for `name`, length must be less than or equal to `256`")
        if self._configuration.client_side_validation and name is not None and len(name) < 0:
            raise ValueError(
                "Invalid value for `name`, length must be greater than or equal to `0`"
            )

        self._name = name

    @property
    def app_ids_to_add(self):
        # type: () -> list[str]
        """Gets the app_ids_to_add of this AppScanSaaSModelsV2UpdateBusinessUnitModel.


        :return: The app_ids_to_add of this AppScanSaaSModelsV2UpdateBusinessUnitModel.
        :rtype: list[str]
        """
        return self._app_ids_to_add

    @app_ids_to_add.setter
    def app_ids_to_add(self, app_ids_to_add):
        """Sets the app_ids_to_add of this AppScanSaaSModelsV2UpdateBusinessUnitModel.


        :param app_ids_to_add: The app_ids_to_add of this AppScanSaaSModelsV2UpdateBusinessUnitModel.
        :type: list[str]
        """

        self._app_ids_to_add = app_ids_to_add

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in self.swagger_types.items():
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(
                    map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value)
                )
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict())
                        if hasattr(item[1], "to_dict")
                        else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value
        if issubclass(AppScanSaaSModelsV2UpdateBusinessUnitModel, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AppScanSaaSModelsV2UpdateBusinessUnitModel):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AppScanSaaSModelsV2UpdateBusinessUnitModel):
            return True

        return self.to_dict() != other.to_dict()
