"""
    HCL AppScan on Cloud (v2)

    This API allows you to interact with the service. The API allows you to perform many of the operations available in the UI and more.</br>For authentication, use the relevant APIs in the Account section. A successful authentication response includes a bearer token for use in subsequent API calls. Pasting this token in the 'Access token' field above will automatically add the authorization header to any API call that requires a valid session.

    OpenAPI spec version: v2

    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

from pyasoc.configuration import Configuration


class AppScanSaaSModelsV2WebhookAssociation:
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {"scope": "str", "scope_id": "str"}

    attribute_map = {"scope": "Scope", "scope_id": "ScopeId"}

    def __init__(self, scope=None, scope_id=None, _configuration=None):
        """AppScanSaaSModelsV2WebhookAssociation - a model defined in Swagger"""
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._scope = None
        self._scope_id = None
        self.discriminator = None

        self.scope = scope
        self.scope_id = scope_id

    @property
    def scope(self):
        # type: () -> str
        """Gets the scope of this AppScanSaaSModelsV2WebhookAssociation.


        :return: The scope of this AppScanSaaSModelsV2WebhookAssociation.
        :rtype: str
        """
        return self._scope

    @scope.setter
    def scope(self, scope):
        """Sets the scope of this AppScanSaaSModelsV2WebhookAssociation.


        :param scope: The scope of this AppScanSaaSModelsV2WebhookAssociation.
        :type: str
        """
        if self._configuration.client_side_validation and scope is None:
            raise ValueError("Invalid value for `scope`, must not be `None`")
        allowed_values = ["AssetGroup", "Application"]
        if self._configuration.client_side_validation and scope not in allowed_values:
            raise ValueError(
                f"Invalid value for `scope` ({scope}), must be one of {allowed_values}"
            )

        self._scope = scope

    @property
    def scope_id(self):
        # type: () -> str
        """Gets the scope_id of this AppScanSaaSModelsV2WebhookAssociation.


        :return: The scope_id of this AppScanSaaSModelsV2WebhookAssociation.
        :rtype: str
        """
        return self._scope_id

    @scope_id.setter
    def scope_id(self, scope_id):
        """Sets the scope_id of this AppScanSaaSModelsV2WebhookAssociation.


        :param scope_id: The scope_id of this AppScanSaaSModelsV2WebhookAssociation.
        :type: str
        """
        if self._configuration.client_side_validation and scope_id is None:
            raise ValueError("Invalid value for `scope_id`, must not be `None`")

        self._scope_id = scope_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in self.swagger_types.items():
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(
                    map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value)
                )
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict())
                        if hasattr(item[1], "to_dict")
                        else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value
        if issubclass(AppScanSaaSModelsV2WebhookAssociation, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AppScanSaaSModelsV2WebhookAssociation):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AppScanSaaSModelsV2WebhookAssociation):
            return True

        return self.to_dict() != other.to_dict()
