"""
    HCL AppScan on Cloud (v2)

    This API allows you to interact with the service. The API allows you to perform many of the operations available in the UI and more.</br>For authentication, use the relevant APIs in the Account section. A successful authentication response includes a bearer token for use in subsequent API calls. Pasting this token in the 'Access token' field above will automatically add the authorization header to any API call that requires a valid session.

    OpenAPI spec version: v2

    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

from pyasoc.configuration import Configuration


class ApplicationResetModel:
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        "delete_issues": "bool",
        "delete_scans": "bool",
        "delete_charts_data": "bool",
    }

    attribute_map = {
        "delete_issues": "DeleteIssues",
        "delete_scans": "DeleteScans",
        "delete_charts_data": "DeleteChartsData",
    }

    def __init__(
        self,
        delete_issues=None,
        delete_scans=None,
        delete_charts_data=None,
        _configuration=None,
    ):
        """ApplicationResetModel - a model defined in Swagger"""
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._delete_issues = None
        self._delete_scans = None
        self._delete_charts_data = None
        self.discriminator = None

        if delete_issues is not None:
            self.delete_issues = delete_issues
        if delete_scans is not None:
            self.delete_scans = delete_scans
        if delete_charts_data is not None:
            self.delete_charts_data = delete_charts_data

    @property
    def delete_issues(self):
        # type: () -> bool
        """Gets the delete_issues of this ApplicationResetModel.


        :return: The delete_issues of this ApplicationResetModel.
        :rtype: bool
        """
        return self._delete_issues

    @delete_issues.setter
    def delete_issues(self, delete_issues):
        """Sets the delete_issues of this ApplicationResetModel.


        :param delete_issues: The delete_issues of this ApplicationResetModel.
        :type: bool
        """

        self._delete_issues = delete_issues

    @property
    def delete_scans(self):
        # type: () -> bool
        """Gets the delete_scans of this ApplicationResetModel.


        :return: The delete_scans of this ApplicationResetModel.
        :rtype: bool
        """
        return self._delete_scans

    @delete_scans.setter
    def delete_scans(self, delete_scans):
        """Sets the delete_scans of this ApplicationResetModel.


        :param delete_scans: The delete_scans of this ApplicationResetModel.
        :type: bool
        """

        self._delete_scans = delete_scans

    @property
    def delete_charts_data(self):
        # type: () -> bool
        """Gets the delete_charts_data of this ApplicationResetModel.


        :return: The delete_charts_data of this ApplicationResetModel.
        :rtype: bool
        """
        return self._delete_charts_data

    @delete_charts_data.setter
    def delete_charts_data(self, delete_charts_data):
        """Sets the delete_charts_data of this ApplicationResetModel.


        :param delete_charts_data: The delete_charts_data of this ApplicationResetModel.
        :type: bool
        """

        self._delete_charts_data = delete_charts_data

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in self.swagger_types.items():
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(
                    map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value)
                )
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict())
                        if hasattr(item[1], "to_dict")
                        else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value
        if issubclass(ApplicationResetModel, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ApplicationResetModel):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ApplicationResetModel):
            return True

        return self.to_dict() != other.to_dict()
