"""
    HCL AppScan on Cloud (v2)

    This API allows you to interact with the service. The API allows you to perform many of the operations available in the UI and more.</br>For authentication, use the relevant APIs in the Account section. A successful authentication response includes a bearer token for use in subsequent API calls. Pasting this token in the 'Access token' field above will automatically add the authorization header to any API call that requires a valid session.

    OpenAPI spec version: v2

    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

from pyasoc.configuration import Configuration


class MicrosoftDataODataQuerySemanticAstFilterClause:
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        "expression": "MicrosoftDataODataQuerySemanticAstSingleValueNode",
        "range_variable": "MicrosoftDataODataQuerySemanticAstRangeVariable",
        "item_type": "MicrosoftDataEdmIEdmTypeReference",
    }

    attribute_map = {
        "expression": "Expression",
        "range_variable": "RangeVariable",
        "item_type": "ItemType",
    }

    def __init__(self, expression=None, range_variable=None, item_type=None, _configuration=None):
        """MicrosoftDataODataQuerySemanticAstFilterClause - a model defined in Swagger"""
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._expression = None
        self._range_variable = None
        self._item_type = None
        self.discriminator = None

        if expression is not None:
            self.expression = expression
        if range_variable is not None:
            self.range_variable = range_variable
        if item_type is not None:
            self.item_type = item_type

    @property
    def expression(self):
        # type: () -> MicrosoftDataODataQuerySemanticAstSingleValueNode
        """Gets the expression of this MicrosoftDataODataQuerySemanticAstFilterClause.


        :return: The expression of this MicrosoftDataODataQuerySemanticAstFilterClause.
        :rtype: MicrosoftDataODataQuerySemanticAstSingleValueNode
        """
        return self._expression

    @expression.setter
    def expression(self, expression):
        """Sets the expression of this MicrosoftDataODataQuerySemanticAstFilterClause.


        :param expression: The expression of this MicrosoftDataODataQuerySemanticAstFilterClause.
        :type: MicrosoftDataODataQuerySemanticAstSingleValueNode
        """

        self._expression = expression

    @property
    def range_variable(self):
        # type: () -> MicrosoftDataODataQuerySemanticAstRangeVariable
        """Gets the range_variable of this MicrosoftDataODataQuerySemanticAstFilterClause.


        :return: The range_variable of this MicrosoftDataODataQuerySemanticAstFilterClause.
        :rtype: MicrosoftDataODataQuerySemanticAstRangeVariable
        """
        return self._range_variable

    @range_variable.setter
    def range_variable(self, range_variable):
        """Sets the range_variable of this MicrosoftDataODataQuerySemanticAstFilterClause.


        :param range_variable: The range_variable of this MicrosoftDataODataQuerySemanticAstFilterClause.
        :type: MicrosoftDataODataQuerySemanticAstRangeVariable
        """

        self._range_variable = range_variable

    @property
    def item_type(self):
        # type: () -> MicrosoftDataEdmIEdmTypeReference
        """Gets the item_type of this MicrosoftDataODataQuerySemanticAstFilterClause.


        :return: The item_type of this MicrosoftDataODataQuerySemanticAstFilterClause.
        :rtype: MicrosoftDataEdmIEdmTypeReference
        """
        return self._item_type

    @item_type.setter
    def item_type(self, item_type):
        """Sets the item_type of this MicrosoftDataODataQuerySemanticAstFilterClause.


        :param item_type: The item_type of this MicrosoftDataODataQuerySemanticAstFilterClause.
        :type: MicrosoftDataEdmIEdmTypeReference
        """

        self._item_type = item_type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in self.swagger_types.items():
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(
                    map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value)
                )
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict())
                        if hasattr(item[1], "to_dict")
                        else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value
        if issubclass(MicrosoftDataODataQuerySemanticAstFilterClause, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, MicrosoftDataODataQuerySemanticAstFilterClause):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, MicrosoftDataODataQuerySemanticAstFilterClause):
            return True

        return self.to_dict() != other.to_dict()
