"""
    HCL AppScan on Cloud (v2)

    This API allows you to interact with the service. The API allows you to perform many of the operations available in the UI and more.</br>For authentication, use the relevant APIs in the Account section. A successful authentication response includes a bearer token for use in subsequent API calls. Pasting this token in the 'Access token' field above will automatically add the authorization header to any API call that requires a valid session.

    OpenAPI spec version: v2

    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

from pyasoc.configuration import Configuration


class SharedComponentsConfigurationsDastUserScanConfiguration:
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        "starting_url": "str",
        "login_user": "str",
        "login_password": "str",
        "extra_field": "str",
        "comment": "str",
        "enablement_message": "str",
        "http_auth_user_name": "str",
        "http_auth_password": "str",
        "http_auth_domain": "str",
        "otp_secret_key": "str",
        "otp_length": "int",
        "otp_hash_type": "str",
        "otp_time_step": "int",
        "otp_http_parameters": "str",
        "thread_num": "int",
        "connection_timeout": "int",
        "use_automatic_timeout": "bool",
        "max_requests_in": "int",
        "max_requests_time_frame": "int",
        "test_policy": "str",
        "test_optimization_level": "str",
        "allowed_domains": "list[str]",
        "postman_collection_json_file_name": "str",
        "postman_environment_json_file_name": "str",
        "postman_global_json_file_name": "str",
        "postman_additional_zip_file_name": "str",
        "should_scan_below_this_directory": "bool",
        "use_case_sensitive_paths": "bool",
    }

    attribute_map = {
        "starting_url": "StartingUrl",
        "login_user": "LoginUser",
        "login_password": "LoginPassword",
        "extra_field": "ExtraField",
        "comment": "Comment",
        "enablement_message": "EnablementMessage",
        "http_auth_user_name": "HttpAuthUserName",
        "http_auth_password": "HttpAuthPassword",
        "http_auth_domain": "HttpAuthDomain",
        "otp_secret_key": "OtpSecretKey",
        "otp_length": "OtpLength",
        "otp_hash_type": "OtpHashType",
        "otp_time_step": "OtpTimeStep",
        "otp_http_parameters": "OtpHttpParameters",
        "thread_num": "ThreadNum",
        "connection_timeout": "ConnectionTimeout",
        "use_automatic_timeout": "UseAutomaticTimeout",
        "max_requests_in": "MaxRequestsIn",
        "max_requests_time_frame": "MaxRequestsTimeFrame",
        "test_policy": "TestPolicy",
        "test_optimization_level": "TestOptimizationLevel",
        "allowed_domains": "AllowedDomains",
        "postman_collection_json_file_name": "PostmanCollectionJsonFileName",
        "postman_environment_json_file_name": "PostmanEnvironmentJsonFileName",
        "postman_global_json_file_name": "PostmanGlobalJsonFileName",
        "postman_additional_zip_file_name": "PostmanAdditionalZipFileName",
        "should_scan_below_this_directory": "ShouldScanBelowThisDirectory",
        "use_case_sensitive_paths": "UseCaseSensitivePaths",
    }

    def __init__(
        self,
        starting_url=None,
        login_user=None,
        login_password=None,
        extra_field=None,
        comment=None,
        enablement_message=None,
        http_auth_user_name=None,
        http_auth_password=None,
        http_auth_domain=None,
        otp_secret_key=None,
        otp_length=None,
        otp_hash_type=None,
        otp_time_step=None,
        otp_http_parameters=None,
        thread_num=None,
        connection_timeout=None,
        use_automatic_timeout=None,
        max_requests_in=None,
        max_requests_time_frame=None,
        test_policy=None,
        test_optimization_level=None,
        allowed_domains=None,
        postman_collection_json_file_name=None,
        postman_environment_json_file_name=None,
        postman_global_json_file_name=None,
        postman_additional_zip_file_name=None,
        should_scan_below_this_directory=None,
        use_case_sensitive_paths=None,
        _configuration=None,
    ):
        """SharedComponentsConfigurationsDastUserScanConfiguration - a model defined in Swagger"""
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._starting_url = None
        self._login_user = None
        self._login_password = None
        self._extra_field = None
        self._comment = None
        self._enablement_message = None
        self._http_auth_user_name = None
        self._http_auth_password = None
        self._http_auth_domain = None
        self._otp_secret_key = None
        self._otp_length = None
        self._otp_hash_type = None
        self._otp_time_step = None
        self._otp_http_parameters = None
        self._thread_num = None
        self._connection_timeout = None
        self._use_automatic_timeout = None
        self._max_requests_in = None
        self._max_requests_time_frame = None
        self._test_policy = None
        self._test_optimization_level = None
        self._allowed_domains = None
        self._postman_collection_json_file_name = None
        self._postman_environment_json_file_name = None
        self._postman_global_json_file_name = None
        self._postman_additional_zip_file_name = None
        self._should_scan_below_this_directory = None
        self._use_case_sensitive_paths = None
        self.discriminator = None

        if starting_url is not None:
            self.starting_url = starting_url
        if login_user is not None:
            self.login_user = login_user
        if login_password is not None:
            self.login_password = login_password
        if extra_field is not None:
            self.extra_field = extra_field
        if comment is not None:
            self.comment = comment
        if enablement_message is not None:
            self.enablement_message = enablement_message
        if http_auth_user_name is not None:
            self.http_auth_user_name = http_auth_user_name
        if http_auth_password is not None:
            self.http_auth_password = http_auth_password
        if http_auth_domain is not None:
            self.http_auth_domain = http_auth_domain
        if otp_secret_key is not None:
            self.otp_secret_key = otp_secret_key
        if otp_length is not None:
            self.otp_length = otp_length
        if otp_hash_type is not None:
            self.otp_hash_type = otp_hash_type
        if otp_time_step is not None:
            self.otp_time_step = otp_time_step
        if otp_http_parameters is not None:
            self.otp_http_parameters = otp_http_parameters
        if thread_num is not None:
            self.thread_num = thread_num
        if connection_timeout is not None:
            self.connection_timeout = connection_timeout
        if use_automatic_timeout is not None:
            self.use_automatic_timeout = use_automatic_timeout
        if max_requests_in is not None:
            self.max_requests_in = max_requests_in
        if max_requests_time_frame is not None:
            self.max_requests_time_frame = max_requests_time_frame
        if test_policy is not None:
            self.test_policy = test_policy
        if test_optimization_level is not None:
            self.test_optimization_level = test_optimization_level
        if allowed_domains is not None:
            self.allowed_domains = allowed_domains
        if postman_collection_json_file_name is not None:
            self.postman_collection_json_file_name = postman_collection_json_file_name
        if postman_environment_json_file_name is not None:
            self.postman_environment_json_file_name = postman_environment_json_file_name
        if postman_global_json_file_name is not None:
            self.postman_global_json_file_name = postman_global_json_file_name
        if postman_additional_zip_file_name is not None:
            self.postman_additional_zip_file_name = postman_additional_zip_file_name
        if should_scan_below_this_directory is not None:
            self.should_scan_below_this_directory = should_scan_below_this_directory
        if use_case_sensitive_paths is not None:
            self.use_case_sensitive_paths = use_case_sensitive_paths

    @property
    def starting_url(self):
        # type: () -> str
        """Gets the starting_url of this SharedComponentsConfigurationsDastUserScanConfiguration.


        :return: The starting_url of this SharedComponentsConfigurationsDastUserScanConfiguration.
        :rtype: str
        """
        return self._starting_url

    @starting_url.setter
    def starting_url(self, starting_url):
        """Sets the starting_url of this SharedComponentsConfigurationsDastUserScanConfiguration.


        :param starting_url: The starting_url of this SharedComponentsConfigurationsDastUserScanConfiguration.
        :type: str
        """

        self._starting_url = starting_url

    @property
    def login_user(self):
        # type: () -> str
        """Gets the login_user of this SharedComponentsConfigurationsDastUserScanConfiguration.


        :return: The login_user of this SharedComponentsConfigurationsDastUserScanConfiguration.
        :rtype: str
        """
        return self._login_user

    @login_user.setter
    def login_user(self, login_user):
        """Sets the login_user of this SharedComponentsConfigurationsDastUserScanConfiguration.


        :param login_user: The login_user of this SharedComponentsConfigurationsDastUserScanConfiguration.
        :type: str
        """

        self._login_user = login_user

    @property
    def login_password(self):
        # type: () -> str
        """Gets the login_password of this SharedComponentsConfigurationsDastUserScanConfiguration.


        :return: The login_password of this SharedComponentsConfigurationsDastUserScanConfiguration.
        :rtype: str
        """
        return self._login_password

    @login_password.setter
    def login_password(self, login_password):
        """Sets the login_password of this SharedComponentsConfigurationsDastUserScanConfiguration.


        :param login_password: The login_password of this SharedComponentsConfigurationsDastUserScanConfiguration.
        :type: str
        """

        self._login_password = login_password

    @property
    def extra_field(self):
        # type: () -> str
        """Gets the extra_field of this SharedComponentsConfigurationsDastUserScanConfiguration.


        :return: The extra_field of this SharedComponentsConfigurationsDastUserScanConfiguration.
        :rtype: str
        """
        return self._extra_field

    @extra_field.setter
    def extra_field(self, extra_field):
        """Sets the extra_field of this SharedComponentsConfigurationsDastUserScanConfiguration.


        :param extra_field: The extra_field of this SharedComponentsConfigurationsDastUserScanConfiguration.
        :type: str
        """

        self._extra_field = extra_field

    @property
    def comment(self):
        # type: () -> str
        """Gets the comment of this SharedComponentsConfigurationsDastUserScanConfiguration.


        :return: The comment of this SharedComponentsConfigurationsDastUserScanConfiguration.
        :rtype: str
        """
        return self._comment

    @comment.setter
    def comment(self, comment):
        """Sets the comment of this SharedComponentsConfigurationsDastUserScanConfiguration.


        :param comment: The comment of this SharedComponentsConfigurationsDastUserScanConfiguration.
        :type: str
        """

        self._comment = comment

    @property
    def enablement_message(self):
        # type: () -> str
        """Gets the enablement_message of this SharedComponentsConfigurationsDastUserScanConfiguration.


        :return: The enablement_message of this SharedComponentsConfigurationsDastUserScanConfiguration.
        :rtype: str
        """
        return self._enablement_message

    @enablement_message.setter
    def enablement_message(self, enablement_message):
        """Sets the enablement_message of this SharedComponentsConfigurationsDastUserScanConfiguration.


        :param enablement_message: The enablement_message of this SharedComponentsConfigurationsDastUserScanConfiguration.
        :type: str
        """

        self._enablement_message = enablement_message

    @property
    def http_auth_user_name(self):
        # type: () -> str
        """Gets the http_auth_user_name of this SharedComponentsConfigurationsDastUserScanConfiguration.


        :return: The http_auth_user_name of this SharedComponentsConfigurationsDastUserScanConfiguration.
        :rtype: str
        """
        return self._http_auth_user_name

    @http_auth_user_name.setter
    def http_auth_user_name(self, http_auth_user_name):
        """Sets the http_auth_user_name of this SharedComponentsConfigurationsDastUserScanConfiguration.


        :param http_auth_user_name: The http_auth_user_name of this SharedComponentsConfigurationsDastUserScanConfiguration.
        :type: str
        """

        self._http_auth_user_name = http_auth_user_name

    @property
    def http_auth_password(self):
        # type: () -> str
        """Gets the http_auth_password of this SharedComponentsConfigurationsDastUserScanConfiguration.


        :return: The http_auth_password of this SharedComponentsConfigurationsDastUserScanConfiguration.
        :rtype: str
        """
        return self._http_auth_password

    @http_auth_password.setter
    def http_auth_password(self, http_auth_password):
        """Sets the http_auth_password of this SharedComponentsConfigurationsDastUserScanConfiguration.


        :param http_auth_password: The http_auth_password of this SharedComponentsConfigurationsDastUserScanConfiguration.
        :type: str
        """

        self._http_auth_password = http_auth_password

    @property
    def http_auth_domain(self):
        # type: () -> str
        """Gets the http_auth_domain of this SharedComponentsConfigurationsDastUserScanConfiguration.


        :return: The http_auth_domain of this SharedComponentsConfigurationsDastUserScanConfiguration.
        :rtype: str
        """
        return self._http_auth_domain

    @http_auth_domain.setter
    def http_auth_domain(self, http_auth_domain):
        """Sets the http_auth_domain of this SharedComponentsConfigurationsDastUserScanConfiguration.


        :param http_auth_domain: The http_auth_domain of this SharedComponentsConfigurationsDastUserScanConfiguration.
        :type: str
        """

        self._http_auth_domain = http_auth_domain

    @property
    def otp_secret_key(self):
        # type: () -> str
        """Gets the otp_secret_key of this SharedComponentsConfigurationsDastUserScanConfiguration.


        :return: The otp_secret_key of this SharedComponentsConfigurationsDastUserScanConfiguration.
        :rtype: str
        """
        return self._otp_secret_key

    @otp_secret_key.setter
    def otp_secret_key(self, otp_secret_key):
        """Sets the otp_secret_key of this SharedComponentsConfigurationsDastUserScanConfiguration.


        :param otp_secret_key: The otp_secret_key of this SharedComponentsConfigurationsDastUserScanConfiguration.
        :type: str
        """

        self._otp_secret_key = otp_secret_key

    @property
    def otp_length(self):
        # type: () -> int
        """Gets the otp_length of this SharedComponentsConfigurationsDastUserScanConfiguration.


        :return: The otp_length of this SharedComponentsConfigurationsDastUserScanConfiguration.
        :rtype: int
        """
        return self._otp_length

    @otp_length.setter
    def otp_length(self, otp_length):
        """Sets the otp_length of this SharedComponentsConfigurationsDastUserScanConfiguration.


        :param otp_length: The otp_length of this SharedComponentsConfigurationsDastUserScanConfiguration.
        :type: int
        """

        self._otp_length = otp_length

    @property
    def otp_hash_type(self):
        # type: () -> str
        """Gets the otp_hash_type of this SharedComponentsConfigurationsDastUserScanConfiguration.


        :return: The otp_hash_type of this SharedComponentsConfigurationsDastUserScanConfiguration.
        :rtype: str
        """
        return self._otp_hash_type

    @otp_hash_type.setter
    def otp_hash_type(self, otp_hash_type):
        """Sets the otp_hash_type of this SharedComponentsConfigurationsDastUserScanConfiguration.


        :param otp_hash_type: The otp_hash_type of this SharedComponentsConfigurationsDastUserScanConfiguration.
        :type: str
        """
        allowed_values = ["Sha1", "None", "Sha256", "Sha512"]
        if self._configuration.client_side_validation and otp_hash_type not in allowed_values:
            raise ValueError(
                "Invalid value for `otp_hash_type` ({}), must be one of {}".format(
                    otp_hash_type, allowed_values
                )
            )

        self._otp_hash_type = otp_hash_type

    @property
    def otp_time_step(self):
        # type: () -> int
        """Gets the otp_time_step of this SharedComponentsConfigurationsDastUserScanConfiguration.


        :return: The otp_time_step of this SharedComponentsConfigurationsDastUserScanConfiguration.
        :rtype: int
        """
        return self._otp_time_step

    @otp_time_step.setter
    def otp_time_step(self, otp_time_step):
        """Sets the otp_time_step of this SharedComponentsConfigurationsDastUserScanConfiguration.


        :param otp_time_step: The otp_time_step of this SharedComponentsConfigurationsDastUserScanConfiguration.
        :type: int
        """

        self._otp_time_step = otp_time_step

    @property
    def otp_http_parameters(self):
        # type: () -> str
        """Gets the otp_http_parameters of this SharedComponentsConfigurationsDastUserScanConfiguration.


        :return: The otp_http_parameters of this SharedComponentsConfigurationsDastUserScanConfiguration.
        :rtype: str
        """
        return self._otp_http_parameters

    @otp_http_parameters.setter
    def otp_http_parameters(self, otp_http_parameters):
        """Sets the otp_http_parameters of this SharedComponentsConfigurationsDastUserScanConfiguration.


        :param otp_http_parameters: The otp_http_parameters of this SharedComponentsConfigurationsDastUserScanConfiguration.
        :type: str
        """

        self._otp_http_parameters = otp_http_parameters

    @property
    def thread_num(self):
        # type: () -> int
        """Gets the thread_num of this SharedComponentsConfigurationsDastUserScanConfiguration.


        :return: The thread_num of this SharedComponentsConfigurationsDastUserScanConfiguration.
        :rtype: int
        """
        return self._thread_num

    @thread_num.setter
    def thread_num(self, thread_num):
        """Sets the thread_num of this SharedComponentsConfigurationsDastUserScanConfiguration.


        :param thread_num: The thread_num of this SharedComponentsConfigurationsDastUserScanConfiguration.
        :type: int
        """

        self._thread_num = thread_num

    @property
    def connection_timeout(self):
        # type: () -> int
        """Gets the connection_timeout of this SharedComponentsConfigurationsDastUserScanConfiguration.


        :return: The connection_timeout of this SharedComponentsConfigurationsDastUserScanConfiguration.
        :rtype: int
        """
        return self._connection_timeout

    @connection_timeout.setter
    def connection_timeout(self, connection_timeout):
        """Sets the connection_timeout of this SharedComponentsConfigurationsDastUserScanConfiguration.


        :param connection_timeout: The connection_timeout of this SharedComponentsConfigurationsDastUserScanConfiguration.
        :type: int
        """

        self._connection_timeout = connection_timeout

    @property
    def use_automatic_timeout(self):
        # type: () -> bool
        """Gets the use_automatic_timeout of this SharedComponentsConfigurationsDastUserScanConfiguration.


        :return: The use_automatic_timeout of this SharedComponentsConfigurationsDastUserScanConfiguration.
        :rtype: bool
        """
        return self._use_automatic_timeout

    @use_automatic_timeout.setter
    def use_automatic_timeout(self, use_automatic_timeout):
        """Sets the use_automatic_timeout of this SharedComponentsConfigurationsDastUserScanConfiguration.


        :param use_automatic_timeout: The use_automatic_timeout of this SharedComponentsConfigurationsDastUserScanConfiguration.
        :type: bool
        """

        self._use_automatic_timeout = use_automatic_timeout

    @property
    def max_requests_in(self):
        # type: () -> int
        """Gets the max_requests_in of this SharedComponentsConfigurationsDastUserScanConfiguration.


        :return: The max_requests_in of this SharedComponentsConfigurationsDastUserScanConfiguration.
        :rtype: int
        """
        return self._max_requests_in

    @max_requests_in.setter
    def max_requests_in(self, max_requests_in):
        """Sets the max_requests_in of this SharedComponentsConfigurationsDastUserScanConfiguration.


        :param max_requests_in: The max_requests_in of this SharedComponentsConfigurationsDastUserScanConfiguration.
        :type: int
        """

        self._max_requests_in = max_requests_in

    @property
    def max_requests_time_frame(self):
        # type: () -> int
        """Gets the max_requests_time_frame of this SharedComponentsConfigurationsDastUserScanConfiguration.


        :return: The max_requests_time_frame of this SharedComponentsConfigurationsDastUserScanConfiguration.
        :rtype: int
        """
        return self._max_requests_time_frame

    @max_requests_time_frame.setter
    def max_requests_time_frame(self, max_requests_time_frame):
        """Sets the max_requests_time_frame of this SharedComponentsConfigurationsDastUserScanConfiguration.


        :param max_requests_time_frame: The max_requests_time_frame of this SharedComponentsConfigurationsDastUserScanConfiguration.
        :type: int
        """

        self._max_requests_time_frame = max_requests_time_frame

    @property
    def test_policy(self):
        # type: () -> str
        """Gets the test_policy of this SharedComponentsConfigurationsDastUserScanConfiguration.


        :return: The test_policy of this SharedComponentsConfigurationsDastUserScanConfiguration.
        :rtype: str
        """
        return self._test_policy

    @test_policy.setter
    def test_policy(self, test_policy):
        """Sets the test_policy of this SharedComponentsConfigurationsDastUserScanConfiguration.


        :param test_policy: The test_policy of this SharedComponentsConfigurationsDastUserScanConfiguration.
        :type: str
        """

        self._test_policy = test_policy

    @property
    def test_optimization_level(self):
        # type: () -> str
        """Gets the test_optimization_level of this SharedComponentsConfigurationsDastUserScanConfiguration.


        :return: The test_optimization_level of this SharedComponentsConfigurationsDastUserScanConfiguration.
        :rtype: str
        """
        return self._test_optimization_level

    @test_optimization_level.setter
    def test_optimization_level(self, test_optimization_level):
        """Sets the test_optimization_level of this SharedComponentsConfigurationsDastUserScanConfiguration.


        :param test_optimization_level: The test_optimization_level of this SharedComponentsConfigurationsDastUserScanConfiguration.
        :type: str
        """
        allowed_values = ["NoOptimization", "Fast", "Faster", "Fastest"]
        if (
            self._configuration.client_side_validation
            and test_optimization_level not in allowed_values
        ):
            raise ValueError(
                "Invalid value for `test_optimization_level` ({}), must be one of {}".format(
                    test_optimization_level, allowed_values
                )
            )

        self._test_optimization_level = test_optimization_level

    @property
    def allowed_domains(self):
        # type: () -> list[str]
        """Gets the allowed_domains of this SharedComponentsConfigurationsDastUserScanConfiguration.


        :return: The allowed_domains of this SharedComponentsConfigurationsDastUserScanConfiguration.
        :rtype: list[str]
        """
        return self._allowed_domains

    @allowed_domains.setter
    def allowed_domains(self, allowed_domains):
        """Sets the allowed_domains of this SharedComponentsConfigurationsDastUserScanConfiguration.


        :param allowed_domains: The allowed_domains of this SharedComponentsConfigurationsDastUserScanConfiguration.
        :type: list[str]
        """

        self._allowed_domains = allowed_domains

    @property
    def postman_collection_json_file_name(self):
        # type: () -> str
        """Gets the postman_collection_json_file_name of this SharedComponentsConfigurationsDastUserScanConfiguration.


        :return: The postman_collection_json_file_name of this SharedComponentsConfigurationsDastUserScanConfiguration.
        :rtype: str
        """
        return self._postman_collection_json_file_name

    @postman_collection_json_file_name.setter
    def postman_collection_json_file_name(self, postman_collection_json_file_name):
        """Sets the postman_collection_json_file_name of this SharedComponentsConfigurationsDastUserScanConfiguration.


        :param postman_collection_json_file_name: The postman_collection_json_file_name of this SharedComponentsConfigurationsDastUserScanConfiguration.
        :type: str
        """

        self._postman_collection_json_file_name = postman_collection_json_file_name

    @property
    def postman_environment_json_file_name(self):
        # type: () -> str
        """Gets the postman_environment_json_file_name of this SharedComponentsConfigurationsDastUserScanConfiguration.


        :return: The postman_environment_json_file_name of this SharedComponentsConfigurationsDastUserScanConfiguration.
        :rtype: str
        """
        return self._postman_environment_json_file_name

    @postman_environment_json_file_name.setter
    def postman_environment_json_file_name(self, postman_environment_json_file_name):
        """Sets the postman_environment_json_file_name of this SharedComponentsConfigurationsDastUserScanConfiguration.


        :param postman_environment_json_file_name: The postman_environment_json_file_name of this SharedComponentsConfigurationsDastUserScanConfiguration.
        :type: str
        """

        self._postman_environment_json_file_name = postman_environment_json_file_name

    @property
    def postman_global_json_file_name(self):
        # type: () -> str
        """Gets the postman_global_json_file_name of this SharedComponentsConfigurationsDastUserScanConfiguration.


        :return: The postman_global_json_file_name of this SharedComponentsConfigurationsDastUserScanConfiguration.
        :rtype: str
        """
        return self._postman_global_json_file_name

    @postman_global_json_file_name.setter
    def postman_global_json_file_name(self, postman_global_json_file_name):
        """Sets the postman_global_json_file_name of this SharedComponentsConfigurationsDastUserScanConfiguration.


        :param postman_global_json_file_name: The postman_global_json_file_name of this SharedComponentsConfigurationsDastUserScanConfiguration.
        :type: str
        """

        self._postman_global_json_file_name = postman_global_json_file_name

    @property
    def postman_additional_zip_file_name(self):
        # type: () -> str
        """Gets the postman_additional_zip_file_name of this SharedComponentsConfigurationsDastUserScanConfiguration.


        :return: The postman_additional_zip_file_name of this SharedComponentsConfigurationsDastUserScanConfiguration.
        :rtype: str
        """
        return self._postman_additional_zip_file_name

    @postman_additional_zip_file_name.setter
    def postman_additional_zip_file_name(self, postman_additional_zip_file_name):
        """Sets the postman_additional_zip_file_name of this SharedComponentsConfigurationsDastUserScanConfiguration.


        :param postman_additional_zip_file_name: The postman_additional_zip_file_name of this SharedComponentsConfigurationsDastUserScanConfiguration.
        :type: str
        """

        self._postman_additional_zip_file_name = postman_additional_zip_file_name

    @property
    def should_scan_below_this_directory(self):
        # type: () -> bool
        """Gets the should_scan_below_this_directory of this SharedComponentsConfigurationsDastUserScanConfiguration.


        :return: The should_scan_below_this_directory of this SharedComponentsConfigurationsDastUserScanConfiguration.
        :rtype: bool
        """
        return self._should_scan_below_this_directory

    @should_scan_below_this_directory.setter
    def should_scan_below_this_directory(self, should_scan_below_this_directory):
        """Sets the should_scan_below_this_directory of this SharedComponentsConfigurationsDastUserScanConfiguration.


        :param should_scan_below_this_directory: The should_scan_below_this_directory of this SharedComponentsConfigurationsDastUserScanConfiguration.
        :type: bool
        """

        self._should_scan_below_this_directory = should_scan_below_this_directory

    @property
    def use_case_sensitive_paths(self):
        # type: () -> bool
        """Gets the use_case_sensitive_paths of this SharedComponentsConfigurationsDastUserScanConfiguration.


        :return: The use_case_sensitive_paths of this SharedComponentsConfigurationsDastUserScanConfiguration.
        :rtype: bool
        """
        return self._use_case_sensitive_paths

    @use_case_sensitive_paths.setter
    def use_case_sensitive_paths(self, use_case_sensitive_paths):
        """Sets the use_case_sensitive_paths of this SharedComponentsConfigurationsDastUserScanConfiguration.


        :param use_case_sensitive_paths: The use_case_sensitive_paths of this SharedComponentsConfigurationsDastUserScanConfiguration.
        :type: bool
        """

        self._use_case_sensitive_paths = use_case_sensitive_paths

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in self.swagger_types.items():
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(
                    map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value)
                )
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict())
                        if hasattr(item[1], "to_dict")
                        else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value
        if issubclass(SharedComponentsConfigurationsDastUserScanConfiguration, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SharedComponentsConfigurationsDastUserScanConfiguration):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, SharedComponentsConfigurationsDastUserScanConfiguration):
            return True

        return self.to_dict() != other.to_dict()
