"""
    HCL AppScan on Cloud (v2)

    This API allows you to interact with the service. The API allows you to perform many of the operations available in the UI and more.</br>For authentication, use the relevant APIs in the Account section. A successful authentication response includes a bearer token for use in subsequent API calls. Pasting this token in the 'Access token' field above will automatically add the authorization header to any API call that requires a valid session.

    OpenAPI spec version: v2

    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

from pyasoc.configuration import Configuration


class SystemWebHttpODataPageResultPolicy:
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {"items": "list[Policy]", "next_page_link": "str", "count": "int"}

    attribute_map = {
        "items": "Items",
        "next_page_link": "NextPageLink",
        "count": "Count",
    }

    def __init__(self, items=None, next_page_link=None, count=None, _configuration=None):
        """SystemWebHttpODataPageResultPolicy - a model defined in Swagger"""
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._items = None
        self._next_page_link = None
        self._count = None
        self.discriminator = None

        if items is not None:
            self.items = items
        if next_page_link is not None:
            self.next_page_link = next_page_link
        if count is not None:
            self.count = count

    @property
    def items(self):
        # type: () -> list[Policy]
        """Gets the items of this SystemWebHttpODataPageResultPolicy.


        :return: The items of this SystemWebHttpODataPageResultPolicy.
        :rtype: list[Policy]
        """
        return self._items

    @items.setter
    def items(self, items):
        """Sets the items of this SystemWebHttpODataPageResultPolicy.


        :param items: The items of this SystemWebHttpODataPageResultPolicy.
        :type: list[Policy]
        """

        self._items = items

    @property
    def next_page_link(self):
        # type: () -> str
        """Gets the next_page_link of this SystemWebHttpODataPageResultPolicy.


        :return: The next_page_link of this SystemWebHttpODataPageResultPolicy.
        :rtype: str
        """
        return self._next_page_link

    @next_page_link.setter
    def next_page_link(self, next_page_link):
        """Sets the next_page_link of this SystemWebHttpODataPageResultPolicy.


        :param next_page_link: The next_page_link of this SystemWebHttpODataPageResultPolicy.
        :type: str
        """

        self._next_page_link = next_page_link

    @property
    def count(self):
        # type: () -> int
        """Gets the count of this SystemWebHttpODataPageResultPolicy.


        :return: The count of this SystemWebHttpODataPageResultPolicy.
        :rtype: int
        """
        return self._count

    @count.setter
    def count(self, count):
        """Sets the count of this SystemWebHttpODataPageResultPolicy.


        :param count: The count of this SystemWebHttpODataPageResultPolicy.
        :type: int
        """

        self._count = count

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in self.swagger_types.items():
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(
                    map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value)
                )
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict())
                        if hasattr(item[1], "to_dict")
                        else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value
        if issubclass(SystemWebHttpODataPageResultPolicy, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SystemWebHttpODataPageResultPolicy):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, SystemWebHttpODataPageResultPolicy):
            return True

        return self.to_dict() != other.to_dict()
