"""
    HCL AppScan on Cloud (v2)

    This API allows you to interact with the service. The API allows you to perform many of the operations available in the UI and more.</br>For authentication, use the relevant APIs in the Account section. A successful authentication response includes a bearer token for use in subsequent API calls. Pasting this token in the 'Access token' field above will automatically add the authorization header to any API call that requires a valid session.

    OpenAPI spec version: v2

    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

from pyasoc.configuration import Configuration


class SystemWebHttpODataQueryInlineCountQueryOption:
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        "context": "SystemWebHttpODataODataQueryContext",
        "raw_value": "str",
        "value": "str",
    }

    attribute_map = {"context": "Context", "raw_value": "RawValue", "value": "Value"}

    def __init__(self, context=None, raw_value=None, value=None, _configuration=None):
        """SystemWebHttpODataQueryInlineCountQueryOption - a model defined in Swagger"""
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._context = None
        self._raw_value = None
        self._value = None
        self.discriminator = None

        if context is not None:
            self.context = context
        if raw_value is not None:
            self.raw_value = raw_value
        if value is not None:
            self.value = value

    @property
    def context(self):
        # type: () -> SystemWebHttpODataODataQueryContext
        """Gets the context of this SystemWebHttpODataQueryInlineCountQueryOption.


        :return: The context of this SystemWebHttpODataQueryInlineCountQueryOption.
        :rtype: SystemWebHttpODataODataQueryContext
        """
        return self._context

    @context.setter
    def context(self, context):
        """Sets the context of this SystemWebHttpODataQueryInlineCountQueryOption.


        :param context: The context of this SystemWebHttpODataQueryInlineCountQueryOption.
        :type: SystemWebHttpODataODataQueryContext
        """

        self._context = context

    @property
    def raw_value(self):
        # type: () -> str
        """Gets the raw_value of this SystemWebHttpODataQueryInlineCountQueryOption.


        :return: The raw_value of this SystemWebHttpODataQueryInlineCountQueryOption.
        :rtype: str
        """
        return self._raw_value

    @raw_value.setter
    def raw_value(self, raw_value):
        """Sets the raw_value of this SystemWebHttpODataQueryInlineCountQueryOption.


        :param raw_value: The raw_value of this SystemWebHttpODataQueryInlineCountQueryOption.
        :type: str
        """

        self._raw_value = raw_value

    @property
    def value(self):
        # type: () -> str
        """Gets the value of this SystemWebHttpODataQueryInlineCountQueryOption.


        :return: The value of this SystemWebHttpODataQueryInlineCountQueryOption.
        :rtype: str
        """
        return self._value

    @value.setter
    def value(self, value):
        """Sets the value of this SystemWebHttpODataQueryInlineCountQueryOption.


        :param value: The value of this SystemWebHttpODataQueryInlineCountQueryOption.
        :type: str
        """
        allowed_values = ["None", "AllPages"]
        if self._configuration.client_side_validation and value not in allowed_values:
            raise ValueError(
                f"Invalid value for `value` ({value}), must be one of {allowed_values}"
            )

        self._value = value

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in self.swagger_types.items():
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(
                    map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value)
                )
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict())
                        if hasattr(item[1], "to_dict")
                        else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value
        if issubclass(SystemWebHttpODataQueryInlineCountQueryOption, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SystemWebHttpODataQueryInlineCountQueryOption):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, SystemWebHttpODataQueryInlineCountQueryOption):
            return True

        return self.to_dict() != other.to_dict()
