"""
    HCL AppScan on Cloud (v2)

    This API allows you to interact with the service. The API allows you to perform many of the operations available in the UI and more.</br>For authentication, use the relevant APIs in the Account section. A successful authentication response includes a bearer token for use in subsequent API calls. Pasting this token in the 'Access token' field above will automatically add the authorization header to any API call that requires a valid session.

    OpenAPI spec version: v2

    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

from pyasoc.configuration import Configuration


class SystemWebHttpODataQueryOrderByQueryOption:
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        "context": "SystemWebHttpODataODataQueryContext",
        "order_by_nodes": "list[SystemWebHttpODataQueryOrderByNode]",
        "raw_value": "str",
        "validator": "SystemWebHttpODataQueryValidatorsOrderByQueryValidator",
        "order_by_clause": "MicrosoftDataODataQuerySemanticAstOrderByClause",
    }

    attribute_map = {
        "context": "Context",
        "order_by_nodes": "OrderByNodes",
        "raw_value": "RawValue",
        "validator": "Validator",
        "order_by_clause": "OrderByClause",
    }

    def __init__(
        self,
        context=None,
        order_by_nodes=None,
        raw_value=None,
        validator=None,
        order_by_clause=None,
        _configuration=None,
    ):
        """SystemWebHttpODataQueryOrderByQueryOption - a model defined in Swagger"""
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._context = None
        self._order_by_nodes = None
        self._raw_value = None
        self._validator = None
        self._order_by_clause = None
        self.discriminator = None

        if context is not None:
            self.context = context
        if order_by_nodes is not None:
            self.order_by_nodes = order_by_nodes
        if raw_value is not None:
            self.raw_value = raw_value
        if validator is not None:
            self.validator = validator
        if order_by_clause is not None:
            self.order_by_clause = order_by_clause

    @property
    def context(self):
        # type: () -> SystemWebHttpODataODataQueryContext
        """Gets the context of this SystemWebHttpODataQueryOrderByQueryOption.


        :return: The context of this SystemWebHttpODataQueryOrderByQueryOption.
        :rtype: SystemWebHttpODataODataQueryContext
        """
        return self._context

    @context.setter
    def context(self, context):
        """Sets the context of this SystemWebHttpODataQueryOrderByQueryOption.


        :param context: The context of this SystemWebHttpODataQueryOrderByQueryOption.
        :type: SystemWebHttpODataODataQueryContext
        """

        self._context = context

    @property
    def order_by_nodes(self):
        # type: () -> list[SystemWebHttpODataQueryOrderByNode]
        """Gets the order_by_nodes of this SystemWebHttpODataQueryOrderByQueryOption.


        :return: The order_by_nodes of this SystemWebHttpODataQueryOrderByQueryOption.
        :rtype: list[SystemWebHttpODataQueryOrderByNode]
        """
        return self._order_by_nodes

    @order_by_nodes.setter
    def order_by_nodes(self, order_by_nodes):
        """Sets the order_by_nodes of this SystemWebHttpODataQueryOrderByQueryOption.


        :param order_by_nodes: The order_by_nodes of this SystemWebHttpODataQueryOrderByQueryOption.
        :type: list[SystemWebHttpODataQueryOrderByNode]
        """

        self._order_by_nodes = order_by_nodes

    @property
    def raw_value(self):
        # type: () -> str
        """Gets the raw_value of this SystemWebHttpODataQueryOrderByQueryOption.


        :return: The raw_value of this SystemWebHttpODataQueryOrderByQueryOption.
        :rtype: str
        """
        return self._raw_value

    @raw_value.setter
    def raw_value(self, raw_value):
        """Sets the raw_value of this SystemWebHttpODataQueryOrderByQueryOption.


        :param raw_value: The raw_value of this SystemWebHttpODataQueryOrderByQueryOption.
        :type: str
        """

        self._raw_value = raw_value

    @property
    def validator(self):
        # type: () -> SystemWebHttpODataQueryValidatorsOrderByQueryValidator
        """Gets the validator of this SystemWebHttpODataQueryOrderByQueryOption.


        :return: The validator of this SystemWebHttpODataQueryOrderByQueryOption.
        :rtype: SystemWebHttpODataQueryValidatorsOrderByQueryValidator
        """
        return self._validator

    @validator.setter
    def validator(self, validator):
        """Sets the validator of this SystemWebHttpODataQueryOrderByQueryOption.


        :param validator: The validator of this SystemWebHttpODataQueryOrderByQueryOption.
        :type: SystemWebHttpODataQueryValidatorsOrderByQueryValidator
        """

        self._validator = validator

    @property
    def order_by_clause(self):
        # type: () -> MicrosoftDataODataQuerySemanticAstOrderByClause
        """Gets the order_by_clause of this SystemWebHttpODataQueryOrderByQueryOption.


        :return: The order_by_clause of this SystemWebHttpODataQueryOrderByQueryOption.
        :rtype: MicrosoftDataODataQuerySemanticAstOrderByClause
        """
        return self._order_by_clause

    @order_by_clause.setter
    def order_by_clause(self, order_by_clause):
        """Sets the order_by_clause of this SystemWebHttpODataQueryOrderByQueryOption.


        :param order_by_clause: The order_by_clause of this SystemWebHttpODataQueryOrderByQueryOption.
        :type: MicrosoftDataODataQuerySemanticAstOrderByClause
        """

        self._order_by_clause = order_by_clause

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in self.swagger_types.items():
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(
                    map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value)
                )
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict())
                        if hasattr(item[1], "to_dict")
                        else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value
        if issubclass(SystemWebHttpODataQueryOrderByQueryOption, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SystemWebHttpODataQueryOrderByQueryOption):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, SystemWebHttpODataQueryOrderByQueryOption):
            return True

        return self.to_dict() != other.to_dict()
