"""
    HCL AppScan on Cloud (v2)

    This API allows you to interact with the service. The API allows you to perform many of the operations available in the UI and more.</br>For authentication, use the relevant APIs in the Account section. A successful authentication response includes a bearer token for use in subsequent API calls. Pasting this token in the 'Access token' field above will automatically add the authorization header to any API call that requires a valid session.

    OpenAPI spec version: v2

    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

from pyasoc.configuration import Configuration


class UserSiteCommonModelsCountGroupModel:
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        "count": "int",
        "asset_group_ids": "str",
        "id": "str",
        "asm_id": "str",
    }

    attribute_map = {
        "count": "Count",
        "asset_group_ids": "AssetGroupIds",
        "id": "Id",
        "asm_id": "AsmId",
    }

    def __init__(
        self,
        count=None,
        asset_group_ids=None,
        id=None,
        asm_id=None,
        _configuration=None,
    ):
        """UserSiteCommonModelsCountGroupModel - a model defined in Swagger"""
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._count = None
        self._asset_group_ids = None
        self._id = None
        self._asm_id = None
        self.discriminator = None

        if count is not None:
            self.count = count
        if asset_group_ids is not None:
            self.asset_group_ids = asset_group_ids
        if id is not None:
            self.id = id
        if asm_id is not None:
            self.asm_id = asm_id

    @property
    def count(self):
        # type: () -> int
        """Gets the count of this UserSiteCommonModelsCountGroupModel.


        :return: The count of this UserSiteCommonModelsCountGroupModel.
        :rtype: int
        """
        return self._count

    @count.setter
    def count(self, count):
        """Sets the count of this UserSiteCommonModelsCountGroupModel.


        :param count: The count of this UserSiteCommonModelsCountGroupModel.
        :type: int
        """

        self._count = count

    @property
    def asset_group_ids(self):
        # type: () -> str
        """Gets the asset_group_ids of this UserSiteCommonModelsCountGroupModel.


        :return: The asset_group_ids of this UserSiteCommonModelsCountGroupModel.
        :rtype: str
        """
        return self._asset_group_ids

    @asset_group_ids.setter
    def asset_group_ids(self, asset_group_ids):
        """Sets the asset_group_ids of this UserSiteCommonModelsCountGroupModel.


        :param asset_group_ids: The asset_group_ids of this UserSiteCommonModelsCountGroupModel.
        :type: str
        """

        self._asset_group_ids = asset_group_ids

    @property
    def id(self):
        # type: () -> str
        """Gets the id of this UserSiteCommonModelsCountGroupModel.


        :return: The id of this UserSiteCommonModelsCountGroupModel.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this UserSiteCommonModelsCountGroupModel.


        :param id: The id of this UserSiteCommonModelsCountGroupModel.
        :type: str
        """

        self._id = id

    @property
    def asm_id(self):
        # type: () -> str
        """Gets the asm_id of this UserSiteCommonModelsCountGroupModel.


        :return: The asm_id of this UserSiteCommonModelsCountGroupModel.
        :rtype: str
        """
        return self._asm_id

    @asm_id.setter
    def asm_id(self, asm_id):
        """Sets the asm_id of this UserSiteCommonModelsCountGroupModel.


        :param asm_id: The asm_id of this UserSiteCommonModelsCountGroupModel.
        :type: str
        """

        self._asm_id = asm_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in self.swagger_types.items():
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(
                    map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value)
                )
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict())
                        if hasattr(item[1], "to_dict")
                        else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value
        if issubclass(UserSiteCommonModelsCountGroupModel, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UserSiteCommonModelsCountGroupModel):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, UserSiteCommonModelsCountGroupModel):
            return True

        return self.to_dict() != other.to_dict()
