"""
    HCL AppScan on Cloud (v2)

    This API allows you to interact with the service. The API allows you to perform many of the operations available in the UI and more.</br>For authentication, use the relevant APIs in the Account section. A successful authentication response includes a bearer token for use in subsequent API calls. Pasting this token in the 'Access token' field above will automatically add the authorization header to any API call that requires a valid session.

    OpenAPI spec version: v2

    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

from pyasoc.configuration import Configuration


class UserSiteCommonModelsFixGroupUpdate:
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {"status": "str", "sticky_status": "bool", "notes": "str"}

    attribute_map = {
        "status": "Status",
        "sticky_status": "StickyStatus",
        "notes": "Notes",
    }

    def __init__(self, status=None, sticky_status=None, notes=None, _configuration=None):
        """UserSiteCommonModelsFixGroupUpdate - a model defined in Swagger"""
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._status = None
        self._sticky_status = None
        self._notes = None
        self.discriminator = None

        if status is not None:
            self.status = status
        if sticky_status is not None:
            self.sticky_status = sticky_status
        if notes is not None:
            self.notes = notes

    @property
    def status(self):
        # type: () -> str
        """Gets the status of this UserSiteCommonModelsFixGroupUpdate.


        :return: The status of this UserSiteCommonModelsFixGroupUpdate.
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this UserSiteCommonModelsFixGroupUpdate.


        :param status: The status of this UserSiteCommonModelsFixGroupUpdate.
        :type: str
        """
        allowed_values = [
            "Open",
            "InProgress",
            "Noise",
            "Passed",
            "Fixed",
            "New",
        ]
        if self._configuration.client_side_validation and status not in allowed_values:
            raise ValueError(
                f"Invalid value for `status` ({status}), must be one of {allowed_values}"
            )

        self._status = status

    @property
    def sticky_status(self):
        # type: () -> bool
        """Gets the sticky_status of this UserSiteCommonModelsFixGroupUpdate.


        :return: The sticky_status of this UserSiteCommonModelsFixGroupUpdate.
        :rtype: bool
        """
        return self._sticky_status

    @sticky_status.setter
    def sticky_status(self, sticky_status):
        """Sets the sticky_status of this UserSiteCommonModelsFixGroupUpdate.


        :param sticky_status: The sticky_status of this UserSiteCommonModelsFixGroupUpdate.
        :type: bool
        """

        self._sticky_status = sticky_status

    @property
    def notes(self):
        # type: () -> str
        """Gets the notes of this UserSiteCommonModelsFixGroupUpdate.


        :return: The notes of this UserSiteCommonModelsFixGroupUpdate.
        :rtype: str
        """
        return self._notes

    @notes.setter
    def notes(self, notes):
        """Sets the notes of this UserSiteCommonModelsFixGroupUpdate.


        :param notes: The notes of this UserSiteCommonModelsFixGroupUpdate.
        :type: str
        """
        if self._configuration.client_side_validation and notes is not None and len(notes) > 2048:
            raise ValueError(
                "Invalid value for `notes`, length must be less than or equal to `2048`"
            )
        if self._configuration.client_side_validation and notes is not None and len(notes) < 0:
            raise ValueError(
                "Invalid value for `notes`, length must be greater than or equal to `0`"
            )

        self._notes = notes

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in self.swagger_types.items():
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(
                    map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value)
                )
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict())
                        if hasattr(item[1], "to_dict")
                        else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value
        if issubclass(UserSiteCommonModelsFixGroupUpdate, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UserSiteCommonModelsFixGroupUpdate):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, UserSiteCommonModelsFixGroupUpdate):
            return True

        return self.to_dict() != other.to_dict()
