"""
    HCL AppScan on Cloud (v2)

    This API allows you to interact with the service. The API allows you to perform many of the operations available in the UI and more.</br>For authentication, use the relevant APIs in the Account section. A successful authentication response includes a bearer token for use in subsequent API calls. Pasting this token in the 'Access token' field above will automatically add the authorization header to any API call that requires a valid session.

    OpenAPI spec version: v2

    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

from pyasoc.configuration import Configuration


class UserSiteCommonModelsGroupCountModel:
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        "group_by": "str",
        "count_groups": "list[UserSiteCommonModelsGroupCountElementModel]",
        "total": "int",
    }

    attribute_map = {
        "group_by": "GroupBy",
        "count_groups": "CountGroups",
        "total": "Total",
    }

    def __init__(self, group_by=None, count_groups=None, total=None, _configuration=None):
        """UserSiteCommonModelsGroupCountModel - a model defined in Swagger"""
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._group_by = None
        self._count_groups = None
        self._total = None
        self.discriminator = None

        if group_by is not None:
            self.group_by = group_by
        if count_groups is not None:
            self.count_groups = count_groups
        if total is not None:
            self.total = total

    @property
    def group_by(self):
        # type: () -> str
        """Gets the group_by of this UserSiteCommonModelsGroupCountModel.


        :return: The group_by of this UserSiteCommonModelsGroupCountModel.
        :rtype: str
        """
        return self._group_by

    @group_by.setter
    def group_by(self, group_by):
        """Sets the group_by of this UserSiteCommonModelsGroupCountModel.


        :param group_by: The group_by of this UserSiteCommonModelsGroupCountModel.
        :type: str
        """

        self._group_by = group_by

    @property
    def count_groups(self):
        # type: () -> list[UserSiteCommonModelsGroupCountElementModel]
        """Gets the count_groups of this UserSiteCommonModelsGroupCountModel.


        :return: The count_groups of this UserSiteCommonModelsGroupCountModel.
        :rtype: list[UserSiteCommonModelsGroupCountElementModel]
        """
        return self._count_groups

    @count_groups.setter
    def count_groups(self, count_groups):
        """Sets the count_groups of this UserSiteCommonModelsGroupCountModel.


        :param count_groups: The count_groups of this UserSiteCommonModelsGroupCountModel.
        :type: list[UserSiteCommonModelsGroupCountElementModel]
        """

        self._count_groups = count_groups

    @property
    def total(self):
        # type: () -> int
        """Gets the total of this UserSiteCommonModelsGroupCountModel.


        :return: The total of this UserSiteCommonModelsGroupCountModel.
        :rtype: int
        """
        return self._total

    @total.setter
    def total(self, total):
        """Sets the total of this UserSiteCommonModelsGroupCountModel.


        :param total: The total of this UserSiteCommonModelsGroupCountModel.
        :type: int
        """

        self._total = total

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in self.swagger_types.items():
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(
                    map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value)
                )
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict())
                        if hasattr(item[1], "to_dict")
                        else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value
        if issubclass(UserSiteCommonModelsGroupCountModel, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UserSiteCommonModelsGroupCountModel):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, UserSiteCommonModelsGroupCountModel):
            return True

        return self.to_dict() != other.to_dict()
