"""
    HCL AppScan on Cloud (v2)

    This API allows you to interact with the service. The API allows you to perform many of the operations available in the UI and more.</br>For authentication, use the relevant APIs in the Account section. A successful authentication response includes a bearer token for use in subsequent API calls. Pasting this token in the 'Access token' field above will automatically add the authorization header to any API call that requires a valid session.

    OpenAPI spec version: v2

    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

from pyasoc.configuration import Configuration


class UserSiteCommonModelsLicenseReportJob:
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        "configuration": "UtilitiesStructuresLicenseReportOptions",
        "odata_filter": "str",
    }

    attribute_map = {"configuration": "Configuration", "odata_filter": "OdataFilter"}

    def __init__(self, configuration=None, odata_filter=None, _configuration=None):
        """UserSiteCommonModelsLicenseReportJob - a model defined in Swagger"""
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._configuration = None
        self._odata_filter = None
        self.discriminator = None

        self.configuration = configuration
        if odata_filter is not None:
            self.odata_filter = odata_filter

    @property
    def configuration(self):
        # type: () -> UtilitiesStructuresLicenseReportOptions
        """Gets the configuration of this UserSiteCommonModelsLicenseReportJob.


        :return: The configuration of this UserSiteCommonModelsLicenseReportJob.
        :rtype: UtilitiesStructuresLicenseReportOptions
        """
        return self._configuration

    @configuration.setter
    def configuration(self, configuration):
        """Sets the configuration of this UserSiteCommonModelsLicenseReportJob.


        :param configuration: The configuration of this UserSiteCommonModelsLicenseReportJob.
        :type: UtilitiesStructuresLicenseReportOptions
        """
        if self._configuration.client_side_validation and configuration is None:
            raise ValueError("Invalid value for `configuration`, must not be `None`")

        self._configuration = configuration

    @property
    def odata_filter(self):
        # type: () -> str
        """Gets the odata_filter of this UserSiteCommonModelsLicenseReportJob.


        :return: The odata_filter of this UserSiteCommonModelsLicenseReportJob.
        :rtype: str
        """
        return self._odata_filter

    @odata_filter.setter
    def odata_filter(self, odata_filter):
        """Sets the odata_filter of this UserSiteCommonModelsLicenseReportJob.


        :param odata_filter: The odata_filter of this UserSiteCommonModelsLicenseReportJob.
        :type: str
        """

        self._odata_filter = odata_filter

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in self.swagger_types.items():
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(
                    map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value)
                )
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict())
                        if hasattr(item[1], "to_dict")
                        else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value
        if issubclass(UserSiteCommonModelsLicenseReportJob, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UserSiteCommonModelsLicenseReportJob):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, UserSiteCommonModelsLicenseReportJob):
            return True

        return self.to_dict() != other.to_dict()
