"""
    HCL AppScan on Cloud (v2)

    This API allows you to interact with the service. The API allows you to perform many of the operations available in the UI and more.</br>For authentication, use the relevant APIs in the Account section. A successful authentication response includes a bearer token for use in subsequent API calls. Pasting this token in the 'Access token' field above will automatically add the authorization header to any API call that requires a valid session.

    OpenAPI spec version: v2

    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

from pyasoc.configuration import Configuration


class UserSiteCommonModelsNewAssetGroupModel:
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        "name": "str",
        "description": "str",
        "issues_status_inheritance": "str",
        "contact_user_id": "str",
    }

    attribute_map = {
        "name": "Name",
        "description": "Description",
        "issues_status_inheritance": "IssuesStatusInheritance",
        "contact_user_id": "ContactUserId",
    }

    def __init__(
        self,
        name=None,
        description=None,
        issues_status_inheritance=None,
        contact_user_id=None,
        _configuration=None,
    ):
        """UserSiteCommonModelsNewAssetGroupModel - a model defined in Swagger"""
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._name = None
        self._description = None
        self._issues_status_inheritance = None
        self._contact_user_id = None
        self.discriminator = None

        self.name = name
        if description is not None:
            self.description = description
        if issues_status_inheritance is not None:
            self.issues_status_inheritance = issues_status_inheritance
        if contact_user_id is not None:
            self.contact_user_id = contact_user_id

    @property
    def name(self):
        # type: () -> str
        """Gets the name of this UserSiteCommonModelsNewAssetGroupModel.


        :return: The name of this UserSiteCommonModelsNewAssetGroupModel.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this UserSiteCommonModelsNewAssetGroupModel.


        :param name: The name of this UserSiteCommonModelsNewAssetGroupModel.
        :type: str
        """
        if self._configuration.client_side_validation and name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")
        if self._configuration.client_side_validation and name is not None and len(name) > 120:
            raise ValueError("Invalid value for `name`, length must be less than or equal to `120`")
        if self._configuration.client_side_validation and name is not None and len(name) < 0:
            raise ValueError(
                "Invalid value for `name`, length must be greater than or equal to `0`"
            )

        self._name = name

    @property
    def description(self):
        # type: () -> str
        """Gets the description of this UserSiteCommonModelsNewAssetGroupModel.


        :return: The description of this UserSiteCommonModelsNewAssetGroupModel.
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this UserSiteCommonModelsNewAssetGroupModel.


        :param description: The description of this UserSiteCommonModelsNewAssetGroupModel.
        :type: str
        """
        if (
            self._configuration.client_side_validation
            and description is not None
            and len(description) > 2048
        ):
            raise ValueError(
                "Invalid value for `description`, length must be less than or equal to `2048`"
            )
        if (
            self._configuration.client_side_validation
            and description is not None
            and len(description) < 0
        ):
            raise ValueError(
                "Invalid value for `description`, length must be greater than or equal to `0`"
            )

        self._description = description

    @property
    def issues_status_inheritance(self):
        # type: () -> str
        """Gets the issues_status_inheritance of this UserSiteCommonModelsNewAssetGroupModel.


        :return: The issues_status_inheritance of this UserSiteCommonModelsNewAssetGroupModel.
        :rtype: str
        """
        return self._issues_status_inheritance

    @issues_status_inheritance.setter
    def issues_status_inheritance(self, issues_status_inheritance):
        """Sets the issues_status_inheritance of this UserSiteCommonModelsNewAssetGroupModel.


        :param issues_status_inheritance: The issues_status_inheritance of this UserSiteCommonModelsNewAssetGroupModel.
        :type: str
        """
        allowed_values = ["None", "Noise", "Fixed"]
        if (
            self._configuration.client_side_validation
            and issues_status_inheritance not in allowed_values
        ):
            raise ValueError(
                "Invalid value for `issues_status_inheritance` ({}), must be one of {}".format(
                    issues_status_inheritance, allowed_values
                )
            )

        self._issues_status_inheritance = issues_status_inheritance

    @property
    def contact_user_id(self):
        # type: () -> str
        """Gets the contact_user_id of this UserSiteCommonModelsNewAssetGroupModel.


        :return: The contact_user_id of this UserSiteCommonModelsNewAssetGroupModel.
        :rtype: str
        """
        return self._contact_user_id

    @contact_user_id.setter
    def contact_user_id(self, contact_user_id):
        """Sets the contact_user_id of this UserSiteCommonModelsNewAssetGroupModel.


        :param contact_user_id: The contact_user_id of this UserSiteCommonModelsNewAssetGroupModel.
        :type: str
        """

        self._contact_user_id = contact_user_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in self.swagger_types.items():
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(
                    map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value)
                )
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict())
                        if hasattr(item[1], "to_dict")
                        else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value
        if issubclass(UserSiteCommonModelsNewAssetGroupModel, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UserSiteCommonModelsNewAssetGroupModel):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, UserSiteCommonModelsNewAssetGroupModel):
            return True

        return self.to_dict() != other.to_dict()
