"""
    HCL AppScan on Cloud (v2)

    This API allows you to interact with the service. The API allows you to perform many of the operations available in the UI and more.</br>For authentication, use the relevant APIs in the Account section. A successful authentication response includes a bearer token for use in subsequent API calls. Pasting this token in the 'Access token' field above will automatically add the authorization header to any API call that requires a valid session.

    OpenAPI spec version: v2

    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

from pyasoc.configuration import Configuration


class UserSiteCommonModelsUpdatePresence:
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {"presence_name": "str"}

    attribute_map = {"presence_name": "PresenceName"}

    def __init__(self, presence_name=None, _configuration=None):
        """UserSiteCommonModelsUpdatePresence - a model defined in Swagger"""
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._presence_name = None
        self.discriminator = None

        self.presence_name = presence_name

    @property
    def presence_name(self):
        # type: () -> str
        """Gets the presence_name of this UserSiteCommonModelsUpdatePresence.


        :return: The presence_name of this UserSiteCommonModelsUpdatePresence.
        :rtype: str
        """
        return self._presence_name

    @presence_name.setter
    def presence_name(self, presence_name):
        """Sets the presence_name of this UserSiteCommonModelsUpdatePresence.


        :param presence_name: The presence_name of this UserSiteCommonModelsUpdatePresence.
        :type: str
        """
        if self._configuration.client_side_validation and presence_name is None:
            raise ValueError("Invalid value for `presence_name`, must not be `None`")
        if (
            self._configuration.client_side_validation
            and presence_name is not None
            and len(presence_name) > 128
        ):
            raise ValueError(
                "Invalid value for `presence_name`, length must be less than or equal to `128`"
            )
        if (
            self._configuration.client_side_validation
            and presence_name is not None
            and len(presence_name) < 1
        ):
            raise ValueError(
                "Invalid value for `presence_name`, length must be greater than or equal to `1`"
            )

        self._presence_name = presence_name

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in self.swagger_types.items():
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(
                    map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value)
                )
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict())
                        if hasattr(item[1], "to_dict")
                        else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value
        if issubclass(UserSiteCommonModelsUpdatePresence, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UserSiteCommonModelsUpdatePresence):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, UserSiteCommonModelsUpdatePresence):
            return True

        return self.to_dict() != other.to_dict()
