"""
    HCL AppScan on Cloud (v2)

    This API allows you to interact with the service. The API allows you to perform many of the operations available in the UI and more.</br>For authentication, use the relevant APIs in the Account section. A successful authentication response includes a bearer token for use in subsequent API calls. Pasting this token in the 'Access token' field above will automatically add the authorization header to any API call that requires a valid session.

    OpenAPI spec version: v2

    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

from pyasoc.configuration import Configuration


class UserSiteCommonModelsVerAndHashes:
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {"version": "int", "hashes": "list[str]"}

    attribute_map = {"version": "Version", "hashes": "Hashes"}

    def __init__(self, version=None, hashes=None, _configuration=None):
        """UserSiteCommonModelsVerAndHashes - a model defined in Swagger"""
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._version = None
        self._hashes = None
        self.discriminator = None

        if version is not None:
            self.version = version
        if hashes is not None:
            self.hashes = hashes

    @property
    def version(self):
        # type: () -> int
        """Gets the version of this UserSiteCommonModelsVerAndHashes.


        :return: The version of this UserSiteCommonModelsVerAndHashes.
        :rtype: int
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this UserSiteCommonModelsVerAndHashes.


        :param version: The version of this UserSiteCommonModelsVerAndHashes.
        :type: int
        """
        if self._configuration.client_side_validation and version is not None and version > 256:
            raise ValueError(
                "Invalid value for `version`, must be a value less than or equal to `256`"
            )
        if self._configuration.client_side_validation and version is not None and version < 0:
            raise ValueError(
                "Invalid value for `version`, must be a value greater than or equal to `0`"
            )

        self._version = version

    @property
    def hashes(self):
        # type: () -> list[str]
        """Gets the hashes of this UserSiteCommonModelsVerAndHashes.


        :return: The hashes of this UserSiteCommonModelsVerAndHashes.
        :rtype: list[str]
        """
        return self._hashes

    @hashes.setter
    def hashes(self, hashes):
        """Sets the hashes of this UserSiteCommonModelsVerAndHashes.


        :param hashes: The hashes of this UserSiteCommonModelsVerAndHashes.
        :type: list[str]
        """

        self._hashes = hashes

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in self.swagger_types.items():
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(
                    map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value)
                )
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict())
                        if hasattr(item[1], "to_dict")
                        else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value
        if issubclass(UserSiteCommonModelsVerAndHashes, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UserSiteCommonModelsVerAndHashes):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, UserSiteCommonModelsVerAndHashes):
            return True

        return self.to_dict() != other.to_dict()
